﻿/*V1.2, Clique, Double Clique, Survole, Maintient du clique, Relachement du clique...
 *Source libre par SitaJONY...
 * Version PC
 * Retrouver la version PPC également...
*/
using System;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Windows.Forms;
using System.Drawing;

namespace Souris_PPC
{
    public class Souris
    {
        private int m1 = 0, m2 = 0;
        public void MouseClick(int x, int y)
        {
            ecran();
            x = x * m1;
            y = y * m2;
            mouse_event(1 | 0x8000, x, y, 0, 0);
            mouse_event(2 | 0x8000, x, y, 0, 0);
            mouse_event(4 | 0x8000, x, y, 0, 0);
        }
        public void MouseDoubleClick(int x, int y)
        {
            ecran();
            x = x * m1;
            y = y * m2;
            mouse_event(1 | 0x8000, x, y, 0, 0);
            mouse_event(2 | 0x8000, x, y, 0, 0);
            mouse_event(4 | 0x8000, x, y, 0, 0);
            mouse_event(2 | 0x8000, x, y, 0, 0);
            mouse_event(4 | 0x8000, x, y, 0, 0);
        }
        public void MouseDrag(int xDebut, int yDebut, int xFin, int yFin)
        {
            ecran();
            int x = xDebut * m1;
            int y = yDebut * m2;
            int x2 = xFin * m1;
            int y2 = yFin * m2;
            mouse_event(1 | 0x8000, x, y, 0, 0);
            mouse_event(2 | 0x8000, x, y, 0, 0);
            while (x != x2 && y != y2)
            {
                if (x < x2) x++;
                if (x > x2) x--;
                if (y < y2) y++;
                if (y > y2) y--;
                mouse_event(1 | 0x8000, x, y, 0, 0);
            }
            mouse_event(4 | 0x8000, x2, y2, 0, 0);

        }
        public void MouseUp(int x, int y)
        {
            ecran();
            x = x * m1;
            y = y * m2;
            mouse_event(1 | 0x8000, x, y, 0, 0);
            mouse_event(4 | 0x8000, x, y, 0, 0);
        }
        public void MouseDown(int x, int y)
        {
            ecran();
            x = x * m1;
            y = y * m2;
            mouse_event(1 | 0x8000, x, y, 0, 0);
            mouse_event(2 | 0x8000, x, y, 0, 0);
        }
        public void MouseMove(int x, int y)
        {
            ecran();
            x = x * m1;
            y = y * m2;
            mouse_event(1 | 0x8000, x, y, 0, 0);
        }
        public double DLLVersion
        {
            get
            {
                return 1.2;
            }
        }
        private void dispose()
        {
        }
        private void ecran()
        {
            
            m1 = (int)Math.Round((double)65535 / Screen.PrimaryScreen.Bounds.Width);
            m2 = (int)Math.Round((double)65535 / Screen.PrimaryScreen.Bounds.Height);
        }
//        [DllImport("coredll.dll")] //Pour PPC
          [DllImport("user32.dll")] //Pour PC
        private static extern void mouse_event(int flags, int x, int y, int data, int extra);

    }
}
